#include "fieldelement.h"

unsigned long long vec_bitops = 0;

extern void mult6(vec *,const vec *,const vec *);
extern void mult7(vec *,const vec *,const vec *);
extern void mult8(vec *,const vec *,const vec *);
extern void mult12(vec *,const vec *,const vec *);
extern void mult13(vec *,const vec *,const vec *);
extern void mult14(vec *,const vec *,const vec *);
extern void mult15(vec *,const vec *,const vec *);
extern void mult27(vec *,const vec *,const vec *);
extern void mult28(vec *,const vec *,const vec *);
extern void mult29(vec *,const vec *,const vec *);
extern void mult30(vec *,const vec *,const vec *);

void mult8(vec *h,const vec *f,const vec *g)
{
  vec f0 = f[0];
  vec g0 = g[0];
  h[0] = f0 * g0;
  vec f1 = f[1];
  vec g1 = g[1];
  h[1] = f1 * g0 + f0 * g1;
  vec f2 = f[2];
  vec g2 = g[2];
  h[2] = f2 * g0 + f1 * g1 + f0 * g2;
  vec f3 = f[3];
  vec g3 = g[3];
  h[3] = f3 * g0 + f2 * g1 + f1 * g2 + f0 * g3;
  vec f4 = f[4];
  vec g4 = g[4];
  vec v0 = f3 * g1 + f2 * g2 + f1 * g3 + f4 * g4;
  vec f5 = f[5];
  vec g5 = g[5];
  vec v1 = f3 * g2 + f2 * g3 + f5 * g4 + f4 * g5;
  vec f6 = f[6];
  vec g6 = g[6];
  vec v2 = f3 * g3 + f6 * g4 + f5 * g5 + f4 * g6;
  vec f7 = f[7];
  vec g7 = g[7];
  h[14] = f7 * g7;
  h[13] = f7 * g6 + f6 * g7;
  h[12] = f7 * g5 + f6 * g6 + f5 * g7;
  h[11] = f7 * g4 + f6 * g5 + f5 * g6 + f4 * g7;
  vec f10 = f[0] + f[4];
  vec f11 = f[1] + f[5];
  vec g10 = g[0] + g[4];
  vec g11 = g[1] + g[5];
  h[4] = v0 + h[0] + f10 * g10;
  h[5] = v1 + h[1] + f11 * g10 + f10 * g11;
  vec f12 = f[2] + f[6];
  vec f13 = f[3] + f[7];
  vec g12 = g[2] + g[6];
  vec g13 = g[3] + g[7];
  h[8] = h[12] + v0 + f13 * g11 + f12 * g12 + f11 * g13;
  h[9] = h[13] + v1 + f13 * g12 + f12 * g13;
  h[6] = v2 + h[2] + f12 * g10 + f11 * g11 + f10 * g12;
  h[10] = h[14] + v2 + f13 * g13;
  h[7] = h[11] + h[3] + f13 * g10 + f12 * g11 + f11 * g12 + f10 * g13;
}

void mult13(vec *h,const vec *f,const vec *g)
{
  mult12(h,f,g);
  vec f12 = f[12];
  vec g12 = g[12];
  h[12] = h[12] + f[0] * g12 + f12 * g[0];
  h[13] = h[13] + f[1] * g12 + f12 * g[1];
  h[14] = h[14] + f[2] * g12 + f12 * g[2];
  h[15] = h[15] + f[3] * g12 + f12 * g[3];
  h[16] = h[16] + f[4] * g12 + f12 * g[4];
  h[17] = h[17] + f[5] * g12 + f12 * g[5];
  h[18] = h[18] + f[6] * g12 + f12 * g[6];
  h[19] = h[19] + f[7] * g12 + f12 * g[7];
  h[20] = h[20] + f[8] * g12 + f12 * g[8];
  h[21] = h[21] + f[9] * g12 + f12 * g[9];
  h[22] = h[22] + f[10] * g12 + f12 * g[10];
  h[23] = f[11] * g12 + f12 * g[11];
  h[24] = f12 * g12;
}

void mult14(vec *h,const vec *f,const vec *g)
{
  vec f1[7];
  vec g1[7];
  vec u[2 * 7 - 1];
  int i;
  mult7(h,f,g);
  mult7(h + 2 * 7,f + 7,g + 7);
  for (i = 0;i < 7;++i) f1[i] = f[i] + f[7 + i];
  for (i = 0;i < 7;++i) g1[i] = g[i] + g[7 + i];
  mult7(u,f1,g1);
  for (i = 0;i < 7 - 1;++i) {
    vec v = h[i + 7] + h[i + 2 * 7];
    h[i + 7] = v + h[i] + u[i];
    h[i + 2 * 7] = h[i + 3 * 7] + v + u[i + 7];
  }
  h[2 * 7 - 1] = h[3 * 7 - 1] + h[7 - 1] + u[7 - 1];
}

void mult15(vec *h,const vec *f,const vec *g)
{
  vec f1[8];
  vec g1[8];
  vec u[16 - 1];
  int i;
  mult8(h,f,g);
  mult7(h + 16,f + 8,g + 8);
  for (i = 0;i < 8 - 1;++i) f1[i] = f[i] + f[8 + i]; f1[8 - 1] = f[8 - 1];
  for (i = 0;i < 8 - 1;++i) g1[i] = g[i] + g[8 + i]; g1[8 - 1] = g[8 - 1];
  mult8(u,f1,g1);
  for (i = 0;i < 8 - 3;++i) {
    vec v = h[i + 8] + h[i + 16];
    h[i + 8] = v + h[i] + u[i];
    h[i + 16] = h[i + 24] + v + u[i + 8];
  }
  for (i = 8 - 3;i < 8 - 1;++i) {
    vec v = h[i + 8] + h[i + 16];
    h[i + 8] = v + h[i] + u[i];
    h[i + 16] = v + u[i + 8];
  }
  h[16 - 1] = h[24 - 1] + h[i] + u[i];
}

void mult27(vec *h,const vec *f,const vec *g)
{
  const int n = 7;
  vec f1[2 * n];
  vec f2[n];
  vec f3[n];
  vec f4[n];
  vec g1[2 * n];
  vec g2[n];
  vec g3[n];
  vec g4[n];
  vec u[2 * 2 * n - 1];
  vec u2[2 * n - 1];
  vec u3[2 * n - 1];
  vec u4[2 * n - 1];
  int i;

  for (i = 0;i < n - 1;++i) {
    vec fi0 = f[i];
    vec fi1 = f[i + n];
    vec fi2 = f[i + 2 * n];
    vec fi3 = f[i + 3 * n];
    vec u = fi0 + fi1;
    vec v = fi2 + fi3;
    f1[i] = fi0 + fi2;
    f1[i + n] = fi1 + fi3;
    f2[i] = u;
    f3[i] = v;
    f4[i] = u + v;
  }
  for (i = n - 1;i < n;++i) {
    vec fi0 = f[i];
    vec fi1 = f[i + n];
    vec fi2 = f[i + 2 * n];
    vec u = fi0 + fi1;
    vec v = fi2;
    f1[i] = fi0 + fi2;
    f1[i + n] = fi1;
    f2[i] = u;
    f3[i] = v;
    f4[i] = u + v;
  }
  for (i = 0;i < n - 1;++i) {
    vec gi0 = g[i];
    vec gi1 = g[i + n];
    vec gi2 = g[i + 2 * n];
    vec gi3 = g[i + 3 * n];
    vec u = gi0 + gi1;
    vec v = gi2 + gi3;
    g1[i] = gi0 + gi2;
    g1[i + n] = gi1 + gi3;
    g2[i] = u;
    g3[i] = v;
    g4[i] = u + v;
  }
  for (i = n - 1;i < n;++i) {
    vec gi0 = g[i];
    vec gi1 = g[i + n];
    vec gi2 = g[i + 2 * n];
    vec u = gi0 + gi1;
    vec v = gi2;
    g1[i] = gi0 + gi2;
    g1[i + n] = gi1;
    g2[i] = u;
    g3[i] = v;
    g4[i] = u + v;
  }

  mult7(h,f,g);
  mult7(h + 2 * n,f + n,g + n);
  mult7(h + 2 * 2 * n,f + 2 * n,g + 2 * n);
  mult6(h + 2 * 2 * n + 2 * n,f + 2 * n + n,g + 2 * n + n);
  mult7(u,f1,g1);
  mult7(u + 2 * n,f1 + n,g1 + n);
  mult7(u2,f2,g2);
  mult7(u3,f3,g3);
  mult7(u4,f4,g4);

  for (i = 0;i < n - 3;++i) {
    vec h0 = h[i];
    vec h12 = h[i + n] + h[i + 2 * n];
    vec h34 = h[i + 3 * n] + h[i + 4 * n];
    vec h56 = h[i + 5 * n] + h[i + 6 * n];
    vec h7 = h[i + 7 * n];
    vec x0 = u[i];
    vec x12 = u[i + n] + u[i + 2 * n];
    vec x3 = u[i + 3 * n];
    vec h1 = h12 + h0 + u2[i];
    vec b = h34 + h12 + u2[i + n];
    vec c = h34 + h56 + u3[i];
    vec h6 = h7 + h56 + u3[i + n];
    h[i + n] = h1;
    h[i + 2 * n] = b + h0 + x0;
    h[i + 3 * n] = c + h1 + x12 + x0 + u4[i];
    h[i + 4 * n] = h6 + b + x12 + x3 + u4[i + n];
    h[i + 5 * n] = h7 + c + x3;
    h[i + 6 * n] = h6;
  }
  for (i = n - 3;i < n - 1;++i) {
    vec h0 = h[i];
    vec h12 = h[i + n] + h[i + 2 * n];
    vec h34 = h[i + 3 * n] + h[i + 4 * n];
    vec h56 = h[i + 5 * n] + h[i + 6 * n];
    vec x0 = u[i];
    vec x12 = u[i + n] + u[i + 2 * n];
    vec x3 = u[i + 3 * n];
    vec h1 = h12 + h0 + u2[i];
    vec b = h34 + h12 + u2[i + n];
    vec c = h34 + h56 + u3[i];
    vec h6 = h56 + u3[i + n];
    h[i + n] = h1;
    h[i + 2 * n] = b + h0 + x0;
    h[i + 3 * n] = c + h1 + x12 + x0 + u4[i];
    h[i + 4 * n] = h6 + b + x12 + x3 + u4[i + n];
    h[i + 5 * n] = c + x3;
    h[i + 6 * n] = h6;
  }

  h[2 * n - 1] = h[3 * n - 1] + h[n - 1] + u2[n - 1];
  h[2 * 2 * n + 2 * n - 1] = h[2 * 2 * n + 3 * n - 1] + h[2 * 2 * n + n - 1] + u3[n - 1];
  vec w = u[3 * n - 1] + u[n - 1] + u4[n - 1];
  vec v = h[n - 1 + 2 * n] + h[n - 1 + 2 * 2 * n];
  h[n - 1 + 2 * n] = v + h[n - 1] + u[n - 1];
  h[n - 1 + 2 * 2 * n] = h[n - 1 + 3 * 2 * n] + v + u[n - 1 + 2 * n];
  h[2 * 2 * n - 1] = h[3 * 2 * n - 1] + h[2 * n - 1] + w;
}

void mult28(vec *h,const vec *f,const vec *g)
{
  const int n = 7;
  vec f1[2 * n];
  vec f2[n];
  vec f3[n];
  vec f4[n];
  vec g1[2 * n];
  vec g2[n];
  vec g3[n];
  vec g4[n];
  vec u[2 * 2 * n - 1];
  vec u2[2 * n - 1];
  vec u3[2 * n - 1];
  vec u4[2 * n - 1];
  int i;

  for (i = 0;i < n;++i) {
    vec fi0 = f[i];
    vec fi1 = f[i + n];
    vec fi2 = f[i + 2 * n];
    vec fi3 = f[i + 3 * n];
    vec u = fi0 + fi1;
    vec v = fi2 + fi3;
    f1[i] = fi0 + fi2;
    f1[i + n] = fi1 + fi3;
    f2[i] = u;
    f3[i] = v;
    f4[i] = u + v;
  }
  for (i = 0;i < n;++i) {
    vec gi0 = g[i];
    vec gi1 = g[i + n];
    vec gi2 = g[i + 2 * n];
    vec gi3 = g[i + 3 * n];
    vec u = gi0 + gi1;
    vec v = gi2 + gi3;
    g1[i] = gi0 + gi2;
    g1[i + n] = gi1 + gi3;
    g2[i] = u;
    g3[i] = v;
    g4[i] = u + v;
  }

  mult7(h,f,g);
  mult7(h + 2 * n,f + n,g + n);
  mult7(h + 2 * 2 * n,f + 2 * n,g + 2 * n);
  mult7(h + 2 * 2 * n + 2 * n,f + 2 * n + n,g + 2 * n + n);
  mult7(u,f1,g1);
  mult7(u + 2 * n,f1 + n,g1 + n);
  mult7(u2,f2,g2);
  mult7(u3,f3,g3);
  mult7(u4,f4,g4);

  for (i = 0;i < n - 1;++i) {
    vec h0 = h[i];
    vec h12 = h[i + n] + h[i + 2 * n];
    vec h34 = h[i + 3 * n] + h[i + 4 * n];
    vec h56 = h[i + 5 * n] + h[i + 6 * n];
    vec h7 = h[i + 7 * n];
    vec x0 = u[i];
    vec x12 = u[i + n] + u[i + 2 * n];
    vec x3 = u[i + 3 * n];
    vec h1 = h12 + h0 + u2[i];
    vec b = h34 + h12 + u2[i + n];
    vec c = h34 + h56 + u3[i];
    vec h6 = h7 + h56 + u3[i + n];
    h[i + n] = h1;
    h[i + 2 * n] = b + h0 + x0;
    h[i + 3 * n] = c + h1 + x12 + x0 + u4[i];
    h[i + 4 * n] = h6 + b + x12 + x3 + u4[i + n];
    h[i + 5 * n] = h7 + c + x3;
    h[i + 6 * n] = h6;
  }

  h[2 * n - 1] = h[3 * n - 1] + h[n - 1] + u2[n - 1];
  h[2 * 2 * n + 2 * n - 1] = h[2 * 2 * n + 3 * n - 1] + h[2 * 2 * n + n - 1] + u3[n - 1];
  vec w = u[3 * n - 1] + u[n - 1] + u4[n - 1];
  vec v = h[n - 1 + 2 * n] + h[n - 1 + 2 * 2 * n];
  h[n - 1 + 2 * n] = v + h[n - 1] + u[n - 1];
  h[n - 1 + 2 * 2 * n] = h[n - 1 + 3 * 2 * n] + v + u[n - 1 + 2 * n];
  h[2 * 2 * n - 1] = h[3 * 2 * n - 1] + h[2 * n - 1] + w;
}

void mult29(vec *h,const vec *f,const vec *g)
{
  const int n = 7;
  vec f1[2 * n];
  vec f2[n];
  vec f3[n];
  vec f4[n];
  vec g1[2 * n];
  vec g2[n];
  vec g3[n];
  vec g4[n];
  vec u[2 * 2 * n - 1];
  vec u2[2 * n - 1];
  vec u3[2 * n - 1];
  vec u4[2 * n - 1];
  int i;

  for (i = 0;i < n;++i) {
    vec fi0 = f[i];
    vec fi1 = f[i + n];
    vec fi2 = f[i + 2 * n];
    vec fi3 = f[i + 3 * n];
    vec u = fi0 + fi1;
    vec v = fi2 + fi3;
    f1[i] = fi0 + fi2;
    f1[i + n] = fi1 + fi3;
    f2[i] = u;
    f3[i] = v;
    f4[i] = u + v;
  }
  for (i = 0;i < n;++i) {
    vec gi0 = g[i];
    vec gi1 = g[i + n];
    vec gi2 = g[i + 2 * n];
    vec gi3 = g[i + 3 * n];
    vec u = gi0 + gi1;
    vec v = gi2 + gi3;
    g1[i] = gi0 + gi2;
    g1[i + n] = gi1 + gi3;
    g2[i] = u;
    g3[i] = v;
    g4[i] = u + v;
  }

  mult7(h,f,g);
  mult7(h + 2 * n,f + n,g + n);
  mult7(h + 2 * 2 * n,f + 2 * n,g + 2 * n);
  mult7(h + 2 * 2 * n + 2 * n,f + 2 * n + n,g + 2 * n + n);
  mult7(u,f1,g1);
  mult7(u + 2 * n,f1 + n,g1 + n);
  mult7(u2,f2,g2);
  mult7(u3,f3,g3);
  mult7(u4,f4,g4);

  vec f28 = f[28];
  vec g28 = g[28];

  for (i = 0;i < n - 1;++i) {
    vec h0 = h[i];
    vec h12 = h[i + n] + h[i + 2 * n];
    vec h34 = h[i + 3 * n] + h[i + 4 * n];
    vec h56 = h[i + 5 * n] + h[i + 6 * n];
    vec h7 = h[i + 7 * n];
    vec x0 = u[i];
    vec x12 = u[i + n] + u[i + 2 * n];
    vec x3 = u[i + 3 * n];
    vec h1 = h12 + h0 + u2[i];
    vec b = h34 + h12 + u2[i + n];
    vec c = h34 + h56 + u3[i];
    vec h6 = h7 + h56 + u3[i + n];
    h[i + n] = h1;
    h[i + 2 * n] = b + h0 + x0;
    h[i + 3 * n] = c + h1 + x12 + x0 + u4[i];
    h[i + 4 * n] = h6 + b + x12 + x3 + u4[i + n] + f28 * g[i] + g28 * f[i];
    h[i + 5 * n] = h7 + c + x3 + f28 * g[i + n] + g28 * f[i + n];
    h[i + 6 * n] = h6 + f28 * g[i + 2 * n] + g28 * f[i + 2 * n];
    h[i + 7 * n] = h7 + f28 * g[i + 3 * n] + g28 * f[i + 3 * n];
  }

  h[2 * n - 1] = h[3 * n - 1] + h[n - 1] + u2[n - 1];
  h[2 * 2 * n + 2 * n - 1] = h[2 * 2 * n + 3 * n - 1] + h[2 * 2 * n + n - 1] + u3[n - 1];
  vec w = u[3 * n - 1] + u[n - 1] + u4[n - 1];
  vec v = h[n - 1 + 2 * n] + h[n - 1 + 2 * 2 * n];
  h[n - 1 + 2 * n] = v + h[n - 1] + u[n - 1];
  h[n - 1 + 2 * 2 * n] = h[n - 1 + 3 * 2 * n] + v + u[n - 1 + 2 * n];
  h[2 * 2 * n - 1] = h[3 * 2 * n - 1] + h[2 * n - 1] + w;

  i = 6; h[i + 28] = h[i + 28] + f28 * g[i] + g28 * f[i];
  i = 13; h[i + 28] = h[i + 28] + f28 * g[i] + g28 * f[i];
  i = 20; h[i + 28] = h[i + 28] + f28 * g[i] + g28 * f[i];
  h[55] = f28 * g[27] + g28 * f[27];
  h[56] = f28 * g28;
}

void mult30(vec *h,const vec *f,const vec *g)
{
  vec f1[15];
  vec f2[8];
  vec f3[8];
  vec f4[8];
  vec g1[15];
  vec g2[8];
  vec g3[8];
  vec g4[8];
  vec u[30 - 1];
  vec u2[15];
  vec u3[15];
  vec u4[15];
  int i;

  vec r0;
  vec r1;
  vec r2;
  vec r3;

  for (i = 0;i < 7;++i) {
    r0 = f[i];
    r1 = f[i + 8];
    r2 = f[i + 15];
    r3 = f[i + 23];
    vec u = r0 + r1;
    vec v = r2 + r3;
    f1[i] = r0 + r2;
    f1[i + 8] = r1 + r3;
    f2[i] = u;
    f3[i] = v;
    f4[i] = u + v;
  }
  r0 = f[7];
  r1 = f[22];
  f2[7] = r0;
  f3[7] = r1;
  r0 = r0 + r1;
  f1[7] = r0;
  f4[7] = r0;

  for (i = 0;i < 7;++i) {
    r0 = g[i];
    r1 = g[i + 8];
    r2 = g[i + 15];
    r3 = g[i + 23];
    vec u = r0 + r1;
    vec v = r2 + r3;
    g1[i] = r0 + r2;
    g1[i + 8] = r1 + r3;
    g2[i] = u;
    g3[i] = v;
    g4[i] = u + v;
  }
  r0 = g[7];
  r1 = g[22];
  g2[7] = r0;
  g3[7] = r1;
  r0 = r0 + r1;
  g1[7] = r0;
  g4[7] = r0;

  mult8(h,f,g);
  mult7(h + 16,f + 8,g + 8);
  mult8(h + 30,f + 15,g + 15);
  mult7(h + 46,f + 23,g + 23);
  mult8(u,f1,g1);
  mult7(u + 16,f1 + 8,g1 + 8);
  mult8(u2,f2,g2);
  mult8(u3,f3,g3);
  mult8(u4,f4,g4);

  h[16 - 1] = h[24 - 1] + h[i] + u2[i];
  h[30 + 16 - 1] = h[30 + 24 - 1] + h[30 + i] + u3[i];
  u[16 - 1] = u[24 - 1] + u[i] + u4[i];
  for (i = 0;i < 8 - 3;++i) {
    vec h0 = h[i];
    vec h12 = h[i + 8] + h[i + 16];
    vec h4 = h[i + 30];
    vec r = h12 + h0 + u2[i];
    h[i + 8] = r;
    h[i + 16] = h[i + 24] + h12 + u2[i + 8];
    vec h56 = h[i + 38] + h[i + 46];
    vec s = h56 + h4 + u3[i];
    h[i + 38] = s;
    h[i + 46] = h[i + 54] + h56 + u3[i + 8];
    vec u0 = u[i];
    vec u12 = u[i + 8] + u[i + 16];
    u[i + 16] = u[i + 24] + u12 + u4[i + 8];
    vec v = h[i + 15] + h4;
    h[i + 15] = v + h0 + u0;
    h[i + 30] = h[i + 45] + v + u[i + 15];
    vec w = h[i + 23] + s;
    h[i + 23] = w + r + u12 + u0 + u4[i];
    h[i + 38] = h[i + 53] + w + u[i + 23];
  }
  for (i = 8 - 3;i < 8 - 1;++i) {
    vec h12 = h[i + 8] + h[i + 16];
    h[i + 8] = h12 + h[i] + u2[i];
    h[i + 16] = h12 + u2[i + 8];
    vec h56 = h[i + 38] + h[i + 46];
    h[i + 38] = h56 + h[i + 30] + u3[i];
    h[i + 46] = h56 + u3[i + 8];
    vec u12 = u[i + 8] + u[i + 16];
    u[i + 8] = u12 + u[i] + u4[i];
    u[i + 16] = u12 + u4[i + 8];
  }
  for (i = 8 - 3;i < 8;++i) {
    vec v = h[i + 15] + h[i + 30];
    h[i + 15] = v + h[i] + u[i];
    h[i + 30] = h[i + 45] + v + u[i + 15];
  }
  for (i = 8 - 3;i < 8 - 2;++i) {
    vec w = h[i + 23] + h[i + 38];
    h[i + 23] = w + h[i + 8] + u[i + 8];
    h[i + 38] = h[i + 53] + w + u[i + 23];
  }
  h[30 - 1] = h[45 - 1] + h[15 - 1] + u[15 - 1];
}

// f1[28],ft[28+1],ft1[28+1],f[28]
void mult83_eval(vec *f1,vec *ft,vec *ft1,const vec *f)
{
  int i;
  vec c = f[28];
  ft[0] = f[0];
  f1[28 - 1] = f[28 - 1] + f[28 - 1 + 28];
  f1[0] = f[0] + f[0 + 28] + f[0 + 2 * 28];
  for (i = 1;i < 28 - 1;i += 2) {
    vec a = f[i];
    vec b = f[i + 28];
    vec d;
    vec e = f[i + 2 * 28];
    ft[i] = a + c;
    d = a + b + e;
    f1[i] = d;
    ft1[i] = d + c;
    c = b + f[2 * 28 + i - 1];
    a = f[i + 1];
    b = f[i + 1 + 28];
    ft[i + 1] = a + c;
    d = a + b + f[i + 1 + 2 * 28];
    f1[i + 1] = d;
    ft1[i + 1] = d + c;
    c = b + e;
  }
  ft[28 - 1] = f[28 - 1] + c;
  ft1[28 - 1] = f1[28 - 1] + c;
  c = f[28 + 28 - 1] + f[2 * 28 + 28 - 1 - 1];
  ft1[0] = f1[0];
  ft[28] = c;
  ft1[28] = c;
}

// h1[2*n-1],ht[2*n+1],ht1[2*n+1]; h0[2*n-1] in h; hinf[2*n-3] in h+4*n
void mult83_interp(vec *h,const vec *h1,const vec *ht,const vec *ht1)
{
  const int n = 28;
  int i;
  vec vsum;
  vec r[2 * n + 1];
  vec v[3 * n + 1]; 
  vec u[2 * n - 1]; 
  for (i = 0;i < 4;++i) {
    r[i] = ht[i] + ht1[i];
    r[i + n] = ht[i + n] + ht1[i + n];
  }
  for (i = 0;i < 1;++i) r[i + 2 * n] = ht[i + 2 * n] + ht1[i + 2 * n];
  for (i = n - 2;i < n;++i) r[i + n] = ht[i + n] + ht1[i + n];
  for (i = n - 2;i < n;++i) r[i] = ht[i] + ht1[i];
  vsum = h[1] + ht[1] + r[0] + h[4 * n];
  v[0] = vsum;
  for (i = 2;i < 4;++i) {
    vsum = vsum + h[i] + ht[i] + r[i - 1] + h[4 * n + i - 1];
    v[i - 1] = vsum;
  }
  for (i = 0;i < 1;++i) v[i + 2 * n] = ht[i + 2 * n] + r[i + 2 * n - 1] + r[i + n] + h[6 * n + i - 4];
  for (i = 1;i < 2;++i) v[i + 2 * n] = r[i + 2 * n - 1] + r[i + n];
  for (i = 2;i < 3;++i) v[i + 2 * n] = r[i + n];
  for (i = 3;i < 4;++i) v[i + 2 * n] = r[i + n];
  for (i = 0;i < 1;++i) v[i + 3 * n] = r[i + 2 * n];
  for (i = 0;i < 4;++i) {
    vec hin = h[i + n];
    vec c = hin + h[i] + h1[i];
    vec d = hin + h1[i + n];
    u[i] = c;
    u[i + n] = d;
    v[i + n] = ht[i + n] + r[i + n - 1] + r[i] + c + h[5 * n + i - 1] + h[5 * n + i - 4];
    v[i + 2 * n] = v[i + 2 * n] + d;
  }
  vec a = r[3];
  vec b = r[3 + n];
  for (i = 4;i < n - 2;++i) {
    vec hi = h[i];
    vec hin = h[i + n];
    vec hti = ht[i];
    vec htin = ht[i + n];
    vec e = h[4 * n + i - 1] + h[4 * n + i - 4] + a;
    vec f = h[5 * n + i - 1] + h[5 * n + i - 4] + b;
    a = hti + ht1[i];
    b = htin + ht1[i + n];
    vec c = hin + hi + h1[i];
    vec d = hin + h1[i + n];
    u[i] = c;
    u[i + n] = d;
    vsum = vsum + hti + hi + e;
    v[i - 1] = vsum;
    v[i + n] = htin + a + c + f;
    v[i + 2 * n] = b + d;
  }
  vsum = vsum + ht[n - 2] + a;
  v[n - 2 + n] = ht[n - 2 + n] + b + r[n - 2];
  for (i = n - 2;i < n - 1;++i) u[i] = h[i + n] + h[i] + h1[i];
  for (i = n - 2;i < n - 1;++i) u[i + n] = h[i + n] + h1[i + n];
  for (i = n - 2;i < n - 1;++i) vsum = vsum + h[i] + h[4 * n + i - 1] + h[4 * n + i - 4];
  for (i = n - 2;i < n - 1;++i) v[i + n] = v[i + n] + u[i] + h[5 * n + i - 4];
  for (i = n - 2;i < n - 1;++i) v[i + 2 * n] = r[i + n] + u[i + n];
  v[n - 3] = vsum;
  for (i = n - 1;i < n;++i) v[i + 2 * n] = r[i + n];
  for (i = n - 1;i < n;++i) u[i] = h[i] + h1[i];
  for (i = n - 1;i < n;++i) vsum = vsum + ht[i] + r[i - 1] + h[i] + h[4 * n + i - 1] + h[4 * n + i - 4];
  for (i = n - 1;i < n;++i) v[i + n] = ht[i + n] + r[i + n - 1] + r[i] + u[i] + h[5 * n + i - 4];
  v[n - 2] = vsum;

  vsum = vsum + v[n];
  v[n - 1] = vsum;
  for (i = 0;i < n;++i) { vsum = vsum + v[i + n + 1]; v[i + n] = vsum; }
  for (i = 0;i < n - 3;++i) {
    vec vi = v[i];
    vec vin = v[i + n];
    vec a = h[i + 4 * n];
    vsum = vsum + v[i + 2 * n + 1];
    h[i + n] = u[i] + a + vi;
    h[i + 2 * n] = u[i + n] + h[5 * n + i] + vin + vi;
    h[i + 3 * n] = vsum + vin;
    h[i + 4 * n] = vsum + a;
  }
  for (i = n - 3;i < n - 1;++i) { vsum = vsum + v[i + 2 * n + 1]; v[i + 2 * n] = vsum; }
  for (i = n - 3;i < n;++i) h[i + n] = u[i] + h[4 * n + i] + v[i];
  for (i = n - 3;i < n - 1;++i) h[i + 2 * n] = u[i + n] + v[i + n] + v[i];
  for (i = n - 1;i < n;++i) h[i + 2 * n] = v[i + n] + v[i];
  for (i = n - 3;i < n - 1;++i) h[i + 3 * n] = v[i + 2 * n] + v[i + n];
  for (i = n - 1;i < n;++i) h[i + 3 * n] = v[i + n];
  for (i = n - 3;i < n - 1;++i) h[i + 4 * n] = v[i + 2 * n] + h[i + 4 * n];
}

void mult83(vec *h,const vec *f,const vec *g)
{
  vec f1[28];
  vec g1[28];
  vec h1[2 * 28 - 1];
  vec ft[28 + 1];
  vec gt[28 + 1];
  vec ht[2 * 28 + 1];
  vec ft1[28 + 1];
  vec gt1[28 + 1];
  vec ht1[2 * 28 + 1];
  mult28(h,f,g);
  mult27(h + 4 * 28,f + 2 * 28,g + 2 * 28);
  mult83_eval(f1,ft,ft1,f);
  mult83_eval(g1,gt,gt1,g);
  mult28(h1,f1,g1);
  mult29(ht,ft,gt);
  mult29(ht1,ft1,gt1);
  mult83_interp(h,h1,ht,ht1);
}

// f1[28],ft[30],ft1[30]
void mult84_eval(vec *f1,vec *ft,vec *ft1,const vec *f)
{
  int i;
  vec fi;
  vec fi28;
  vec fi56;
  vec f12i;
  fi = f[0];
  fi28 = f[28];
  fi56 = f[56];
  f1[0] = fi + fi28 + fi56;
  ft[0] = fi;
  ft1[0] = f1[0];
  f12i = fi28;
  for (i = 1;i < 27;i += 2) {
    vec a;
    fi = f[i];
    fi28 = f[i + 28];
    a = fi28 + fi56;
    fi56 = f[i + 56];
    vec b = fi + fi28 + fi56;
    f1[i] = b;
    ft[i] = fi + f12i;
    ft1[i] = b + f12i;
    f12i = a;
    fi = f[i + 1];
    fi28 = f[i + 1 + 28];
    a = fi28 + fi56;
    fi56 = f[i + 1 + 56];
    b = fi + fi28 + fi56;
    f1[i + 1] = b;
    ft[i + 1] = fi + f12i;
    ft1[i + 1] = b + f12i;
    f12i = a;
  }
    vec a;
    fi = f[i];
    fi28 = f[i + 28];
    a = fi28 + fi56;
    fi56 = f[i + 56];
    vec b = fi + fi28 + fi56;
    f1[i] = b;
    ft[i] = fi + f12i;
    ft1[i] = b + f12i;
    f12i = a;
  ft[28] = f12i;
  ft[29] = fi56;
  ft1[28] = f12i;
  ft1[29] = fi56;
}

// h1[55],ht[59],ht1[59]; h0[55] already in h; hinf[55] already in h+2*56
void mult84_interp(vec *h,const vec *h1,const vec *ht,const vec *ht1)
{
  int i;
  vec r[57];
  vec v[85]; 
  vec u[55]; 
  vec vsum;

  for (i = 0;i < 4;++i) r[i] = ht[i] + ht1[i];
  for (i = 0;i < 4;++i) r[i + 28] = ht[i + 28] + ht1[i + 28];
  for (i = 0;i < 1;++i) r[i + 56] = ht[i + 56] + ht1[i + 56];
  for (i = 27;i < 28;++i) r[i] = ht[i] + ht1[i];
  for (i = 27;i < 28;++i) r[i + 28] = ht[i + 28] + ht1[i + 28];

  for (i = 1;i < 4;++i)
  vsum = ht[1] + r[1 - 1] + h[1] + h[112 + 1 - 1];
  v[0] = vsum;
  vsum = vsum + ht[2] + r[2 - 1] + h[2] + h[112 + 2 - 1];
  v[1] = vsum;
  vsum = vsum + ht[3] + r[3 - 1] + h[3] + h[112 + 3 - 1];
  v[2] = vsum;
  for (i = 0;i < 4;++i) {
    vec ui = h[i + 28] + h[i] + h1[i];
    u[i] = ui;
    v[i + 28] = ht[i + 28] + r[i + 27] + r[i] + ui + h[140 + i - 1] + h[140 + i - 4];
  }
  for (i = 0;i < 2;++i) {
    vec ui28 = h[i + 28] + h1[i + 28];
    u[i + 28] = ui28;
    v[i + 56] = ht[i + 56] + r[i + 55] + r[i + 28] + ui28 + h[168 + i - 4];
  }
  for (i = 2;i < 3;++i) {
    vec ui28 = h[i + 28] + h1[i + 28];
    u[i + 28] = ui28;
    v[i + 56] = ht[i + 56] + r[i + 28] + ui28 + h[168 + i - 4];
  }
  for (i = 3;i < 4;++i) {
    vec ui28 = h[i + 28] + h1[i + 28];
    u[i + 28] = ui28;
    v[i + 56] = r[i + 28] + ui28;
  }
  for (i = 0;i < 1;++i) v[i + 84] = r[i + 56];

  vec a = r[3];
  vec b = r[3 + 28];
  for (i = 4;i < 27;++i) {
    vec hi = h[i];
    vec hi28 = h[i + 28];
    vec hti = ht[i];
    vec hti28 = ht[i + 28];
    vec e = h[112 + i - 4] + h[112 + i - 1] + a;
    vec f = h[140 + i - 4] + h[140 + i - 1] + b;
    a = hti + ht1[i];
    b = hti28 + ht1[i + 28];
    vec c = hi28 + hi + h1[i];
    vec d = hi28 + h1[i + 28];
    u[i] = c;
    u[i + 28] = d;
    vsum = vsum + hti + hi + e;
    v[i - 1] = vsum;
    v[i + 28] = hti28 + a + c + f;
    v[i + 56] = b + d;
  }
  for (i = 27;i < 28;++i) {
    vec vin;
    vsum = vsum + ht[i] + a;
    vin = ht[i + 28] + b + r[i];
    v[i + 56] = r[i + 28];
    u[i] = h[i] + h1[i];
    vsum = vsum + h[i];
    vin = vin + u[i];
    vsum = vsum + h[112 + i - 1];
    vin = vin + h[140 + i - 1];
    vsum = vsum + h[112 + i - 4];
    vin = vin + h[140 + i - 4];
    v[i + 28] = vin;
  }

  v[26] = vsum;
  vsum = vsum + v[28];
  v[27] = vsum;
  for (i = 0;i < 28;++i) {
    vsum = vsum + v[i + 29];
    v[i + 28] = vsum;
  }
  for (i = 0;i < 27;++i) {
    vec vi = v[i];
    vec vi28 = v[i + 28];
    vec a = h[i + 112];
    vsum = vsum + v[i + 57];
    h[i + 28] = u[i] + a + vi;
    h[i + 56] = u[i + 28] + h[140 + i] + vi28 + vi;
    h[i + 84] = vsum + vi28;
    h[i + 112] = vsum + a;
  }
  for (i = 27;i < 28;++i) {
    vec vi = v[i];
    vec vin = v[i + 28];
    h[i + 28] = u[i] + h[112 + i] + vi;
    h[i + 56] = vin + vi;
    h[i + 84] = vin;
  }
}

void mult84(vec *h,const vec *f,const vec *g)
{
  vec f1[28];
  vec g1[28];
  vec h1[55];
  vec ft[30];
  vec gt[30];
  vec ht[59];
  vec ft1[30];
  vec gt1[30];
  vec ht1[59];
  mult28(h,f,g);
  mult28(h + 2 * 56,f + 56,g + 56);
  mult84_eval(f1,ft,ft1,f);
  mult84_eval(g1,gt,gt1,g);
  mult28(h1,f1,g1);
  mult30(ht,ft,gt);
  mult30(ht1,ft1,gt1);
  mult84_interp(h,h1,ht,ht1);
}

// f1[29],ft[29+1],ft1[29+1],f[29]
void mult85_eval(vec *f1,vec *ft,vec *ft1,const vec *f)
{
  int i;
  vec c;
  vec fi29;

  for (i = 0;i < 2;++i) f1[i] = f[i] + f[i + 29] + f[i + 2 * 29];
  f1[29 - 2] = f[29 - 2] + f[29 - 2 + 29];
  f1[29 - 1] = f[29 - 1] + f[29 - 1 + 29];
  ft[0] = f[0];

  c = f[29];
  ft[1] = f[1] + c;
  ft1[1] = f1[1] + c;

  fi29 = f[30];
  for (i = 2;i < 29 - 2;++i) {
    vec fi = f[i];
    vec f1i;
    c = fi29 + f[2 * 29 + i - 2];
    fi29 = f[i + 29];
    f1i = fi + fi29 + f[i + 2 * 29];
    f1[i] = f1i;
    ft[i] = fi + c;
    ft1[i] = f1i + c;
  }
  for (i = 29 - 2;i < 29;++i) {
    c = f[29 + i - 1] + f[2 * 29 + i - 2];
    ft[i] = f[i] + c;
    ft1[i] = f1[i] + c;
  }

  c = f[29 + 29 - 1];
  ft1[0] = f1[0];
  ft[29] = c;
  ft1[29] = c;
}

// h1[2*n-1],ht[2*n+1],ht1[2*n+1]; h0[2*n-1] in h; hinf[2*n-5] in h+4*n
void mult85_interp(vec *h,const vec *h1,const vec *ht,const vec *ht1)
{
  int i;
  const int n = 29;
  vec r[2 * n + 1];
  vec v[3 * n + 1]; 
  vec u[2 * n - 1]; 
  vec vsum;

  for (i = 0;i < 4;++i) r[i] = ht[i] + ht1[i];
  for (i = n - 4;i < n;++i) r[i] = ht[i] + ht1[i];
  for (i = 0;i < 4;++i) r[i + n] = ht[i + n] + ht1[i + n];
  for (i = n - 4;i < n;++i) r[i + n] = ht[i + n] + ht1[i + n];

  for (i = 0;i < 1;++i) r[i + 2 * n] = ht[i + 2 * n] + ht1[i + 2 * n];
  vsum = ht[1] + r[0] + h[1] + h[4 * n];
  v[0] = vsum;
  for (i = 2;i < 4;++i) {
    vsum = vsum + ht[i] + r[i - 1] + h[i] + h[4 * n + i - 1];
    v[i - 1] = vsum;
  }
  for (i = 0;i < 1;++i) v[i + 2 * n] = ht[i + 2 * n] + r[i + 2 * n - 1] + r[i + n];
  for (i = 1;i < 2;++i) v[i + 2 * n] = r[i + 2 * n - 1] + r[i + n];
  for (i = 2;i < 3;++i) v[i + 2 * n] = r[i + n];
  for (i = 3;i < 4;++i) v[i + 2 * n] = r[i + n];
  for (i = 0;i < 1;++i) v[i + 3 * n] = r[i + 2 * n];
  for (i = 0;i < 4;++i) {
    u[i] = h[i + n] + h[i] + h1[i];
    u[i + n] = h[i + n] + h1[i + n];
    v[i + n] = ht[i + n] + r[i + n - 1] + r[i];
    v[i + n] = v[i + n] + u[i];
    v[i + n] = v[i + n] + h[5 * n + i - 1];
    v[i + n] = v[i + n] + h[5 * n + i - 4];
    v[i + 2 * n] = v[i + 2 * n] + u[i + n];
  }

  vec a = r[3];
  vec b = r[3 + n];
  for (i = 4;i < n - 4;++i) {
    vec hi = h[i];
    vec hin = h[i + n];
    vec hti = ht[i];
    vec htin = ht[i + n];
    vec e = h[4 * n + i - 1] + h[4 * n + i - 4] + a;
    vec f = h[5 * n + i - 1] + h[5 * n + i - 4] + b;
    a = hti + ht1[i];
    b = htin + ht1[i + n];
    vec c = hin + hi + h1[i];
    vec d = hin + h1[i + n];
    u[i] = c;
    u[i + n] = d;
    vsum = vsum + hti + hi + e;
    v[i - 1] = vsum;
    v[i + n] = htin + a + c + f;
    v[i + 2 * n] = b + d;
  }

  r[n - 5] = a;
  r[2 * n - 5] = b;

  for (i = n - 4;i < n - 1;++i) {
    vec hi = h[i];
    vec hin = h[i + n];
    vec hti = ht[i];
    vec htin = ht[i + n];
    vec c = hin + hi + h1[i];
    vec d = hin + h1[i + n];
    u[i] = c;
    u[i + n] = d;
    vsum = vsum + hti + r[i - 1] + hi + h[4 * n + i - 1] + h[4 * n + i - 4];
    v[i - 1] = vsum;
    v[i + n] = htin + r[i + n - 1] + r[i] + c + h[5 * n + i - 4];
    v[i + 2 * n] = r[i + n] + d;
  }
  for (i = n - 1;i < n;++i) vsum = vsum + ht[i] + r[i - 1] + h[i] + h[4 * n + i - 1] + h[4 * n + i - 4];
  for (i = n - 1;i < n;++i) v[i + 2 * n] = r[i + n];
  for (i = n - 1;i < n;++i) u[i] = h[i] + h1[i];
  for (i = n - 1;i < n;++i) v[i + n] = ht[i + n] + r[i + n - 1] + r[i] + u[i];

  v[n - 2] = vsum;
  vsum = vsum + v[n];
  v[n - 1] = vsum;

  for (i = 0;i < n;++i) { vsum = vsum + v[i + n + 1]; v[i + n] = vsum; }

  for (i = 0;i < n - 5;++i) {
    vec vi = v[i];
    vec vin = v[i + n];
    vec a = h[4 * n + i];
    vsum = vsum + v[i + 2 * n + 1];
    h[i + n] = u[i] + a + vi;
    h[i + 2 * n] = u[i + n] + h[5 * n + i] + vin + vi;
    h[i + 3 * n] = vsum + vin;
    h[i + 4 * n] = vsum + a;
  }

  for (i = n - 5;i < n - 1;++i) {
    vec vi = v[i];
    vec vin = v[i + n];
    vsum = vsum + v[i + 2 * n + 1];
    v[i + 2 * n] = vsum;
    h[i + n] = u[i] + h[4 * n + i] + vi;
    h[i + 2 * n] = u[i + n] + vin + v[i];
    h[i + 3 * n] = vsum + vin;
    h[i + 4 * n] = vsum + h[4 * n + i];
  }
  for (i = n - 1;i < n;++i) h[i + n] = u[i] + h[4 * n + i] + v[i];
  for (i = n - 1;i < n;++i) h[i + 2 * n] = v[i + n] + v[i];
  for (i = n - 1;i < n;++i) h[i + 3 * n] = v[i + n];
}

void mult85(vec *h,const vec *f,const vec *g)
{
  vec f1[29];
  vec g1[29];
  vec h1[2 * 29 - 1];
  vec ft[29 + 1];
  vec gt[29 + 1];
  vec ht[2 * 29 + 1];
  vec ft1[29 + 1];
  vec gt1[29 + 1];
  vec ht1[2 * 29 + 1];
  mult27(h + 4 * 29,f + 2 * 29,g + 2 * 29);
  mult85_eval(f1,ft,ft1,f);
  mult85_eval(g1,gt,gt1,g);
  mult29(h,f,g);
  mult29(h1,f1,g1);
  mult30(ht,ft,gt);
  mult30(ht1,ft1,gt1);
  mult85_interp(h,h1,ht,ht1);
}

// f1[84],ft[84+1],ft1[84+1],f[84]
void mult251_eval(vec *f1,vec *ft,vec *ft1,const vec *f)
{
  int i;
  vec f0 = f[0];
  vec c = f[84];
  ft[0] = f0;
  f1[84 - 1] = f[84 - 1] + f[84 - 1 + 84];
  f1[0] = f0 + c + f[0 + 2 * 84];
  for (i = 1;i < 84 - 1;i += 2) {
    vec a = f[i];
    vec b = f[i + 84];
    vec d;
    vec e = f[i + 2 * 84];
    ft[i] = a + c;
    d = a + b + e;
    f1[i] = d;
    ft1[i] = d + c;
    c = b + f[2 * 84 + i - 1];
    a = f[i + 1];
    b = f[i + 1 + 84];
    ft[i + 1] = a + c;
    d = a + b + f[i + 1 + 2 * 84];
    f1[i + 1] = d;
    ft1[i + 1] = d + c;
    c = b + e;
  }
  ft[84 - 1] = f[84 - 1] + c;
  ft1[84 - 1] = f1[84 - 1] + c;
  c = f[84 + 84 - 1] + f[2 * 84 + 84 - 1 - 1];
  ft1[0] = f1[0];
  ft[84] = c;
  ft1[84] = c;
}

// h1[2*n-1],ht[2*n+1],ht1[2*n+1]; h0[2*n-1] in h; hinf[2*n-3] in h+4*n
void mult251_interp(vec *h,const vec *h1,const vec *ht,const vec *ht1)
{
  const int n = 84;
  int i;
  vec vsum;
  vec r[2 * n + 1];
  vec v[3 * n + 1]; 
  vec u[2 * n - 1]; 
  for (i = 0;i < 4;++i) r[i] = ht[i] + ht1[i];
  for (i = 0;i < 4;++i) r[i + n] = ht[i + n] + ht1[i + n];
  for (i = 0;i < 1;++i) r[i + 2 * n] = ht[i + 2 * n] + ht1[i + 2 * n];
  for (i = n - 2;i < n;++i) r[i + n] = ht[i + n] + ht1[i + n];
  for (i = n - 2;i < n;++i) r[i] = ht[i] + ht1[i];
  vsum = h[1] + ht[1] + r[0] + h[4 * n];
  v[0] = vsum;
  for (i = 2;i < 4;++i) {
    vsum = vsum + h[i] + ht[i] + r[i - 1] + h[4 * n + i - 1];
    v[i - 1] = vsum;
  }
  for (i = 0;i < 1;++i) v[i + 2 * n] = ht[i + 2 * n] + r[i + 2 * n - 1] + r[i + n] + h[6 * n + i - 4];
  for (i = 1;i < 2;++i) v[i + 2 * n] = r[i + 2 * n - 1] + r[i + n];
  for (i = 2;i < 3;++i) v[i + 2 * n] = r[i + n];
  for (i = 3;i < 4;++i) v[i + 2 * n] = r[i + n];
  for (i = 0;i < 1;++i) v[i + 3 * n] = r[i + 2 * n];
  for (i = 0;i < 4;++i) {
    vec hin = h[i + n];
    vec c = hin + h[i] + h1[i];
    vec d = hin + h1[i + n];
    u[i] = c;
    u[i + n] = d;
    v[i + n] = ht[i + n] + r[i + n - 1] + r[i] + c + h[5 * n + i - 1] + h[5 * n + i - 4];
    v[i + 2 * n] = v[i + 2 * n] + d;
  }
  vec a = r[3];
  vec b = r[3 + n];
  for (i = 4;i < n - 2;++i) {
    vec hi = h[i];
    vec hin = h[i + n];
    vec hti = ht[i];
    vec htin = ht[i + n];
    vec e = h[4 * n + i - 1] + h[4 * n + i - 4] + a;
    vec f = h[5 * n + i - 1] + h[5 * n + i - 4] + b;
    a = hti + ht1[i];
    b = htin + ht1[i + n];
    vec c = hin + hi + h1[i];
    vec d = hin + h1[i + n];
    u[i] = c;
    u[i + n] = d;
    vsum = vsum + hti + hi + e;
    v[i - 1] = vsum;
    v[i + n] = htin + a + c + f;
    v[i + 2 * n] = b + d;
  }
  vsum = vsum + ht[n - 2] + a;
  v[n - 2 + n] = ht[n - 2 + n] + b + r[n - 2];
  for (i = n - 2;i < n - 1;++i) u[i] = h[i + n] + h[i] + h1[i];
  for (i = n - 2;i < n - 1;++i) u[i + n] = h[i + n] + h1[i + n];
  for (i = n - 2;i < n - 1;++i) vsum = vsum + h[i] + h[4 * n + i - 1] + h[4 * n + i - 4];
  for (i = n - 2;i < n - 1;++i) v[i + n] = v[i + n] + u[i] + h[5 * n + i - 4];
  for (i = n - 2;i < n - 1;++i) v[i + 2 * n] = r[i + n] + u[i + n];
  v[n - 3] = vsum;
  for (i = n - 1;i < n;++i) v[i + 2 * n] = r[i + n];
  for (i = n - 1;i < n;++i) u[i] = h[i] + h1[i];
  for (i = n - 1;i < n;++i) vsum = vsum + ht[i] + r[i - 1] + h[i] + h[4 * n + i - 1] + h[4 * n + i - 4];
  for (i = n - 1;i < n;++i) v[i + n] = ht[i + n] + r[i + n - 1] + r[i] + u[i] + h[5 * n + i - 4];
  v[n - 2] = vsum;

  vsum = vsum + v[n];
  v[n - 1] = vsum;
  for (i = 0;i < n;++i) { vsum = vsum + v[i + n + 1]; v[i + n] = vsum; }
  for (i = 0;i < n - 3;++i) {
    vec vi = v[i];
    vec vin = v[i + n];
    vec a = h[i + 4 * n];
    vsum = vsum + v[i + 2 * n + 1];
    h[i + n] = u[i] + a + vi;
    h[i + 2 * n] = u[i + n] + h[5 * n + i] + vin + vi;
    h[i + 3 * n] = vsum + vin;
    h[i + 4 * n] = vsum + a;
  }
  for (i = n - 3;i < n - 1;++i) { vsum = vsum + v[i + 2 * n + 1]; v[i + 2 * n] = vsum; }
  for (i = n - 3;i < n;++i) h[i + n] = u[i] + h[4 * n + i] + v[i];
  for (i = n - 3;i < n - 1;++i) h[i + 2 * n] = u[i + n] + v[i + n] + v[i];
  for (i = n - 1;i < n;++i) h[i + 2 * n] = v[i + n] + v[i];
  for (i = n - 3;i < n - 1;++i) h[i + 3 * n] = v[i + 2 * n] + v[i + n];
  for (i = n - 1;i < n;++i) h[i + 3 * n] = v[i + n];
  for (i = n - 3;i < n - 1;++i) h[i + 4 * n] = v[i + 2 * n] + h[i + 4 * n];
}

void mult251(vec *h,const vec *f,const vec *g)
{
  vec f1[84];
  vec g1[84];
  vec h1[2 * 84 - 1];
  vec ft[84 + 1];
  vec gt[84 + 1];
  vec ht[2 * 84 + 1];
  vec ft1[84 + 1];
  vec gt1[84 + 1];
  vec ht1[2 * 84 + 1];
  mult84(h,f,g);
  mult83(h + 4 * 84,f + 2 * 84,g + 2 * 84);
  mult251_eval(f1,ft,ft1,f);
  mult251_eval(g1,gt,gt1,g);
  mult84(h1,f1,g1);
  mult85(ht,ft,gt);
  mult85(ht1,ft1,gt1);
  mult251_interp(h,h1,ht,ht1);
}

void fieldelement::set_0(void)
{
  int i;
  __m128i v = _mm_set_epi32(0,0,0,0);
  for (i = 0;i < 251;++i) x[i] = v;
}

void fieldelement::set_1(void)
{
  int i;
  __m128i v = _mm_set_epi32(0,0,0,0);
  for (i = 0;i < 251;++i) x[i] = v;
  x[0] = _mm_set_epi32(0xffffffff,0xffffffff,0xffffffff,0xffffffff);
}

// overlap ok
void fieldelement::add (fieldelement &result,const fieldelement &b) const
{
  int i;
  for (i = 0;i < 248;i += 4) {
    vec r0 = (*this).x[i];
    vec r1 = (*this).x[i + 1];
    vec r2 = (*this).x[i + 2];
    vec r3 = (*this).x[i + 3];
    r0 = r0 + b.x[i];
    r1 = r1 + b.x[i + 1];
    r2 = r2 + b.x[i + 2];
    r3 = r3 + b.x[i + 3];
    result.x[i] = r0;
    result.x[i + 1] = r1;
    result.x[i + 2] = r2;
    result.x[i + 3] = r3;
  }
  for (i = 248;i < 251;++i) { result.x[i] = (*this).x[i] + b.x[i]; }
}

fieldelement operator+(const fieldelement &a,const fieldelement &b)
{
  fieldelement result;
  a.add(result,b);
  return result;
}

// overlap ok
void fieldelement::multiply(fieldelement &result,const fieldelement &b) const
{
  vec h[501];
  mult251(h,x,b.x);
  int i;
  for (i = 244;i < 250;++i) {
    vec a = h[i + 251];
    h[i + 7] = h[i + 7] + a;
    h[i + 4] = h[i + 4] + a;
    h[i + 2] = h[i + 2] + a;
    h[i + 0] = h[i + 0] + a;
  }
  vec a0 = h[251];
  result.x[0] = h[0] + a0;
  vec a1 = h[252];
  result.x[1] = h[1] + a1;
  vec a2 = h[253]; vec a2a0 = a2 + a0;
  result.x[2] = h[2] + a2a0;
  vec a3 = h[254]; vec a3a1 = a3 + a1;
  result.x[3] = h[3] + a3a1;
  vec a4 = h[255];
  result.x[4] = h[4] + a4 + a2a0;
  vec a5 = h[256];
  result.x[5] = h[5] + a5 + a3a1;
  vec a6 = h[257]; vec a6a4 = a6 + a4;
  result.x[6] = h[6] + a6a4 + a2;
  vec a7 = h[258]; vec a7a5 = a7 + a5;
  for (i = 7;i < 239;i += 8) {
    vec r0 = h[i] + a7a5 + a3 + a0;
    result.x[i] = r0;
    a0 = h[i + 252];
    vec r1 = h[i + 1] + a0 + a6a4 + a1;
    result.x[i + 1] = r1;
    a1 = h[i + 253];
    vec r2 = h[i + 2] + a1 + a7a5 + a2;
    result.x[i + 2] = r2;
    a2 = h[i + 254]; a2a0 = a2 + a0;
    vec r3 = h[i + 3] + a2a0 + a6 + a3;
    result.x[i + 3] = r3;
    a3 = h[i + 255]; a3a1 = a3 + a1;
    vec r4 = h[i + 4] + a3a1 + a7 + a4;
    result.x[i + 4] = r4;
    a4 = h[i + 256];
    vec r5 = h[i + 5] + a4 + a2a0 + a5;
    result.x[i + 5] = r5;
    a5 = h[i + 257];
    vec r6 = h[i + 6] + a5 + a3a1 + a6;
    result.x[i + 6] = r6;
    a6 = h[i + 258]; a6a4 = a6 + a4;
    vec r7 = h[i + 7] + a6a4 + a2 + a7;
    result.x[i + 7] = r7;
    a7 = h[i + 259]; a7a5 = a7 + a5;
  }

  vec r0 = h[i] + a7a5 + a3 + a0;
  result.x[i] = r0;
  a0 = h[i + 252];
  vec r1 = h[i + 1] + a0 + a6a4 + a1;
  result.x[i + 1] = r1;
  a1 = h[i + 253];
  vec r2 = h[i + 2] + a1 + a7a5 + a2;
  result.x[i + 2] = r2;
  a2 = h[i + 254]; a2a0 = a2 + a0;
  vec r3 = h[i + 3] + a2a0 + a6 + a3;
  result.x[i + 3] = r3;
  a3 = h[i + 255]; a3a1 = a3 + a1;
  vec r4 = h[i + 4] + a3a1 + a7 + a4;
  result.x[i + 4] = r4;
  vec r5 = h[i + 5] + a2a0 + a5;
  result.x[i + 5] = r5;
  vec r6 = h[i + 6] + a3a1 + a6;
  result.x[i + 6] = r6;
  vec r7 = h[i + 7] + a2 + a7;
  result.x[i + 7] = r7;
  i += 8;
  r0 = h[i] + a3 + a0;
  result.x[i] = r0;
  r1 = h[i + 1] + a1;
  result.x[i + 1] = r1;
  r2 = h[i + 2] + a2;
  result.x[i + 2] = r2;
  r3 = h[i + 3] + a3;
  result.x[i + 3] = r3;
}

fieldelement operator*(const fieldelement &a,const fieldelement &b)
{
  fieldelement result;
  a.multiply(result,b);
  return result;
}

void fieldelement::putsquare(fieldelement &result) const
{
  vec *h = result.x;
  int i;
  vec a;
  vec b;
  vec u;
  vec v;
  vec w;

  b = x[129];
  v = x[130];

  for (i = 131;i < 247;i += 4) {
    a = x[i];
    u = a + v;
    h[2 * i - 244] = x[i - 122] + a; h[2 * i - 251] = u + b;
    v = x[i + 1];
    h[2 * i - 242] = x[i - 121] + v; h[2 * i - 249] = v + u;
    b = x[i + 2];
    u = b + v;
    h[2 * i - 240] = x[i - 120] + b; h[2 * i - 247] = u + a;
    v = x[i + 3];
    h[2 * i - 238] = x[i - 119] + v; h[2 * i - 245] = v + u;
  }
  
  h[250] = x[125] + x[247];
  h[243] = x[247] + v + b;
  h[245] = x[248] + x[247] + v;
  h[247] = x[249] + x[248] + x[247];
  h[249] = x[250] + x[249] + x[248];

  vec h256 = x[128] + x[250];
  vec h254 = x[127] + x[249];
  vec h253 = x[250];
  vec h252 = x[126] + x[248];
  vec h251 = x[250] + x[249];
  vec e = h256 + h254;

  h[16] = x[8] + x[130];
  h[14] = x[7] + x[129];
  h[12] = x[6] + h256;
  h[10] = x[5] + h254;
  h[8] = x[4] + h252;
  h[6] = x[3] + h253;
  h[4] = x[2] + x[249];
  h[2] = x[1] + x[249];
  h[0] = x[0] + h251;

  h[9] = x[130] + x[129] + h256 + h253;
  h[7] = x[129] + e + h251;
  h[5] = e + h252;
  h[3] = h254 + h252;
  h[1] = h252;
}

fieldelement fieldelement::square(void)
{
  fieldelement result;
  putsquare(result);
  return result;
}

void fieldelement::times_d(fieldelement &result) const
{
  vec *h = result.x;
  int i;

  for (i = 44;i < 54;++i) h[i] = x[i] + x[i - 44];
  for (i = 54;i < 57;++i) h[i] = x[i] + x[i - 44] + x[i - 54];
  for (i = 57;i < 251;++i) h[i] = x[i] + x[i - 44] + x[i - 54] + x[i - 57];

  vec a0;
  vec a1;
  vec a2;
  vec a3;
  vec a4;
  vec a5;
  vec a6;
  vec a7;
  vec a2a0;
  vec a3a1;
  vec a6a4;
  vec a7a5;
  vec r0 = x[0];
  vec r1 = x[1];
  vec r2 = x[2];
  vec r3 = x[3];
  vec r4 = x[4];
  vec r5 = x[5];
  vec r6 = x[6];
  vec r7 = x[7];

  for (i = 251;i < 283;i += 8) {
    a0 = x[i-44] + x[i-54] + x[i-57];
    r7=r7+a0; r0=r0+a0;
    h[i-251] = r0; r0 = x[i-243];
    a1 = x[i-43] + x[i-53] + x[i-56];
    r0=r0+a1; r1=r1+a1;
    h[i-250] = r1; r1 = x[i-242];
    a2 = x[i-42] + x[i-52] + x[i-55];
    a2a0 = a2 + a0;
    r1=r1+a2; r6=r6+a2; r4=r4+a2a0; r2=r2+a2a0;
    h[i-249] = r2; r2 = x[i-241];
    a3 = x[i-41] + x[i-51] + x[i-54];
    a3a1 = a3 + a1;
    r2=r2+a3; r7=r7+a3; r5=r5+a3a1; r3=r3+a3a1;
    h[i-248] = r3; r3 = x[i-240];
    a4 = x[i-40] + x[i-50] + x[i-53];
    r3=r3+a4; r4=r4+a4;
    h[i-247] = r4; r4 = x[i-239];
    a5 = x[i-39] + x[i-49] + x[i-52];
    r4=r4+a5; r5=r5+a5;
    h[i-246] = r5; r5 = x[i-238];
    a6 = x[i-38] + x[i-48] + x[i-51];
    a6a4 = a6 + a4;
    r5=r5+a6; r2=r2+a6; r0=r0+a6a4; r6=r6+a6a4;
    h[i-245] = r6; r6 = x[i-237];
    a7 = x[i-37] + x[i-47] + x[i-50];
    a7a5 = a7 + a5;
    r6=r6+a7; r3=r3+a7; r1=r1+a7a5; r7=r7+a7a5;
    h[i-244] = r7; r7 = x[i-236];
  }

    a0 = x[i-44] + x[i-54] + x[i-57];
    r7=r7+a0; r0=r0+a0;
    h[i-251] = r0; r0 = x[i-243];
    a1 = x[i-43] + x[i-53] + x[i-56];
    r0=r0+a1; r1=r1+a1;
    h[i-250] = r1; r1 = x[i-242];
    a2 = x[i-42] + x[i-52] + x[i-55];
    a2a0 = a2 + a0;
    r1=r1+a2; r6=r6+a2; r4=r4+a2a0; r2=r2+a2a0;
    h[i-249] = r2; r2 = x[i-241];
    a3 = x[i-41] + x[i-51] + x[i-54];
    a3a1 = a3 + a1;
    r2=r2+a3; r7=r7+a3; r5=r5+a3a1; r3=r3+a3a1;
    h[i-248] = r3; r3 = x[i-240];
    a4 = x[i-40] + x[i-50] + x[i-53];
    r3=r3+a4; r4=r4+a4;
    h[i-247] = r4; r4 = h[i-239];
    a5 = x[i-39] + x[i-49] + x[i-52];
    r4=r4+a5; r5=r5+a5;
    h[i-246] = r5; r5 = h[i-238];
    a6 = x[i-38] + x[i-48] + x[i-51];
    a6a4 = a6 + a4;
    r5=r5+a6; r2=r2+a6; r0=r0+a6a4; r6=r6+a6a4;
    h[i-245] = r6; r6 = h[i-237];
    a7 = x[i-37] + x[i-47] + x[i-50];
    a7a5 = a7 + a5;
    r6=r6+a7; r3=r3+a7; r1=r1+a7a5; r7=r7+a7a5;
    h[i-244] = r7; r7 = h[i-236];
    i += 8;

    a0 = x[i-44] + x[i-54] + x[i-57];
    r7=r7+a0; r0=r0+a0;
    h[i-251] = r0; r0 = h[i-243];
    a1 = x[i-43] + x[i-53] + x[i-56];
    r0=r0+a1; r1=r1+a1;
    h[i-250] = r1; r1 = h[i-242];
    a2 = x[i-42] + x[i-52] + x[i-55];
    a2a0 = a2 + a0;
    r1=r1+a2; r6=r6+a2; r4=r4+a2a0; r2=r2+a2a0;
    h[i-249] = r2; r2 = h[i-241];
    a3 = x[i-41] + x[i-51] + x[i-54];
    a3a1 = a3 + a1;
    r2=r2+a3; r7=r7+a3; r5=r5+a3a1; r3=r3+a3a1;
    h[i-248] = r3; r3 = h[i-240];
    a4 = x[i-50] + x[i-53];
    r3=r3+a4; r4=r4+a4;
    h[i-247] = r4; r4 = h[i-239];
    a5 = x[i-49] + x[i-52];
    r4=r4+a5; r5=r5+a5;
    h[i-246] = r5; r5 = h[i-238];
    a6 = x[i-48] + x[i-51];
    a6a4 = a6 + a4;
    r5=r5+a6; r2=r2+a6; r0=r0+a6a4; r6=r6+a6a4;
    h[i-245] = r6; r6 = h[i-237];
    a7 = x[i-47] + x[i-50];
    a7a5 = a7 + a5;
    r6=r6+a7; r3=r3+a7; r1=r1+a7a5; r7=r7+a7a5;
    h[i-244] = r7; r7 = h[i-236];
    i += 8;

    a0 = x[i-54] + x[i-57];
    r7=r7+a0; r0=r0+a0;
    h[i-251] = r0; r0 = h[i-243];
    a1 = x[i-53] + x[i-56];
    r0=r0+a1; r1=r1+a1;
    h[i-250] = r1; r1 = h[i-242];
    a2 = x[i-52] + x[i-55];
    a2a0 = a2 + a0;
    r1=r1+a2; r6=r6+a2; r4=r4+a2a0; r2=r2+a2a0;
    h[i-249] = r2; r2 = h[i-241];
    a3 = x[i-51] + x[i-54];
    a3a1 = a3 + a1;
    r2=r2+a3; r7=r7+a3; r5=r5+a3a1; r3=r3+a3a1;
    h[i-248] = r3; r3 = h[i-240];
    a4 = x[i-50] + x[i-53];
    r3=r3+a4; r4=r4+a4;
    h[i-247] = r4; r4 = h[i-239];
    a5 = x[i-49] + x[i-52];
    r4=r4+a5; r5=r5+a5;
    h[i-246] = r5; r5 = h[i-238];
    a6 = x[i-51];
    a6a4 = a6 + a4;
    r5=r5+a6; r2=r2+a6; r0=r0+a6a4; r6=r6+a6a4;
    h[i-245] = r6; r6 = h[i-237];
    a7 = x[i-50];
    a7a5 = a7 + a5;
    r6=r6+a7; r3=r3+a7; r1=r1+a7a5; r7=r7+a7a5;
    h[i-244] = r7; r7 = h[i-236];
    i += 8;

    a0 = x[i-57]; r7=r7+a0; r4=r4+a0; r2=r2+a0; r0=r0+a0; h[i-251] = r0;
    h[i-250] = r1;
    h[i-249] = r2;
    h[i-248] = r3;
    h[i-247] = r4;
    h[i-246] = r5;
    h[i-245] = r6;
    h[i-244] = r7;
}

fieldelement fieldelement::times_d(void)
{
  fieldelement result;
  times_d(result);
  return result;
}

fieldelement fieldelement::inverse(void)
{
  int i;
  fieldelement u;
  fieldelement v;
  fieldelement w;
  fieldelement r;
  (*this).putsquare(u);
  (*this).multiply(v,u);
  v.putsquare(u);
  (*this).multiply(w,u);
  w.putsquare(u); u.putsquare(v); v.putsquare(u);
  w.multiply(v,u);
  v.putsquare(w); w.putsquare(u);
  for (i = 8;i < 12;i += 2) { u.putsquare(w); w.putsquare(u); }
  v.multiply(w,u);
  w.putsquare(u); u.putsquare(v);
  for (i = 14;i < 24;i += 2) { v.putsquare(u); u.putsquare(v); }
  v.multiply(u,w);
  u.putsquare(v);
  (*this).multiply(w,v);
  w.putsquare(u);
  for (i = 26;i < 50;i += 2) { u.putsquare(v); v.putsquare(u); }
  w.multiply(r,u);
  r.putsquare(v); v.putsquare(u);
  for (i = 52;i < 100;i += 2) { u.putsquare(v); v.putsquare(u); }
  r.multiply(v,u);
  v.putsquare(u);
  for (i = 101;i < 125;i += 2) { u.putsquare(v); v.putsquare(u); }
  w.multiply(v,u);
  v.putsquare(u);
  for (i = 126;i < 250;i += 2) { u.putsquare(w); w.putsquare(u); }
  v.multiply(w,u);
  w.putsquare(u);
  return u;
}

fieldelement fieldelement::bbe251(const vec n[251])
{
  fieldelement Z2; Z2.set_1();
  fieldelement W2; W2.set_0();
  vec control = n[250];
  fieldelement W3; W3 = *this;
  fieldelement Z3; Z3.set_1();
  fieldelement C;
  fieldelement D;
  int i;
  for (i = 250;i >= 0;--i) {
    conditionalswap(W2,W3,control);
    conditionalswap(Z2,Z3,control);
    Z2.add(C,W2);
    C.multiply(D,W2);
    Z3.add(C,W3);
    C.multiply(C,D);
    C.multiply(C,W3);
    D.putsquare(W2);
    Z3.multiply(Z3,Z2);
    Z2.putsquare(D);
    D.putsquare(Z2);
    Z2.times_d(D);
    D.add(Z2,W2);
    Z3.putsquare(D);
    D.times_d(Z3);
    Z3.add(Z3,C);
    Z3.multiply(W3,*this);
    W3.add(W3,C);
    if (i > 0) control = n[i] + n[i - 1];
  }
  conditionalswap(W2,W3,n[0]);
  conditionalswap(Z2,Z3,n[0]);
  return W2 * Z2.inverse();
}
