#include "fieldelement.h"

unsigned long long vec_bitops = 0;

#include "251.cpp"

static void mult251(vec *h,const vec *f,const vec *g)
{
  vec r[NUMREGS];
  int i;
  for (i = 0;i < sizeof(arith)/sizeof(*arith);++i) {
    vec x;
    vec y;
    vec z;
    if (arith[i].x == 'f') x = f[arith[i].xn];
    else if (arith[i].x == 'g') x = g[arith[i].xn];
    else if (arith[i].x == 'r') x = r[arith[i].xn];
    else abort();
    if (arith[i].op == '$') {
      z = x;
    } else {
      if (arith[i].y == 'f') y = f[arith[i].yn];
      else if (arith[i].y == 'g') y = g[arith[i].yn];
      else if (arith[i].y == 'r') y = r[arith[i].yn];
      else abort();
      if (arith[i].op == '+') z = x + y; else z = x * y;
    }
    if (arith[i].z == 'h') h[arith[i].zn] = z;
    else if (arith[i].z == 'r') r[arith[i].zn] = z;
    else abort();
  }
}

void fieldelement::set_0(void)
{
  int i;
  for (i = 0;i < 251;++i) x[i] = _mm_set_epi32(0,0,0,0);
}

void fieldelement::set_1(void)
{
  int i;
  for (i = 0;i < 251;++i) x[i] = _mm_set_epi32(0,0,0,0);
  x[0] = _mm_set_epi32(0xffffffff,0xffffffff,0xffffffff,0xffffffff);
}

// overlap ok
void fieldelement::add (fieldelement &result,const fieldelement &b) const
{
  int i;
  for (i = 0;i < 251;++i) result.x[i] = (*this).x[i] + b.x[i];
}

fieldelement operator+(const fieldelement &a,const fieldelement &b)
{
  fieldelement result;
  a.add(result,b);
  return result;
}

void conditionalswap(fieldelement &a,fieldelement &b,vec control)
{
  int i;
  for (i = 0;i < 251;++i) {
    vec a0 = a.x[i];
    vec b0 = b.x[i];
    vec d0 = a0 + b0;
    d0 = d0 * control;
    a0 = a0 + d0;
    b0 = b0 + d0;
    a.x[i] = a0;
    b.x[i] = b0;
  }
}

// overlap ok
void fieldelement::multiply(fieldelement &result,const fieldelement &b) const
{
  vec h[501];
  mult251(h,x,b.x);
  int i;
  for (i = 244;i < 250;++i) {
    vec a = h[i + 251];
    h[i + 7] = h[i + 7] + a;
    h[i + 4] = h[i + 4] + a;
    h[i + 2] = h[i + 2] + a;
    h[i + 0] = h[i + 0] + a;
  }
  vec a0 = h[251];
  result.x[0] = h[0] + a0;
  vec a1 = h[252];
  result.x[1] = h[1] + a1;
  vec a2 = h[253]; vec a2a0 = a2 + a0;
  result.x[2] = h[2] + a2a0;
  vec a3 = h[254]; vec a3a1 = a3 + a1;
  result.x[3] = h[3] + a3a1;
  vec a4 = h[255];
  result.x[4] = h[4] + a4 + a2a0;
  vec a5 = h[256];
  result.x[5] = h[5] + a5 + a3a1;
  vec a6 = h[257]; vec a6a4 = a6 + a4;
  result.x[6] = h[6] + a6a4 + a2;
  vec a7 = h[258]; vec a7a5 = a7 + a5;
  for (i = 7;i < 239;i += 8) {
    vec r0 = h[i] + a7a5 + a3 + a0;
    result.x[i] = r0;
    a0 = h[i + 252];
    vec r1 = h[i + 1] + a0 + a6a4 + a1;
    result.x[i + 1] = r1;
    a1 = h[i + 253];
    vec r2 = h[i + 2] + a1 + a7a5 + a2;
    result.x[i + 2] = r2;
    a2 = h[i + 254]; a2a0 = a2 + a0;
    vec r3 = h[i + 3] + a2a0 + a6 + a3;
    result.x[i + 3] = r3;
    a3 = h[i + 255]; a3a1 = a3 + a1;
    vec r4 = h[i + 4] + a3a1 + a7 + a4;
    result.x[i + 4] = r4;
    a4 = h[i + 256];
    vec r5 = h[i + 5] + a4 + a2a0 + a5;
    result.x[i + 5] = r5;
    a5 = h[i + 257];
    vec r6 = h[i + 6] + a5 + a3a1 + a6;
    result.x[i + 6] = r6;
    a6 = h[i + 258]; a6a4 = a6 + a4;
    vec r7 = h[i + 7] + a6a4 + a2 + a7;
    result.x[i + 7] = r7;
    a7 = h[i + 259]; a7a5 = a7 + a5;
  }

  vec r0 = h[i] + a7a5 + a3 + a0;
  result.x[i] = r0;
  a0 = h[i + 252];
  vec r1 = h[i + 1] + a0 + a6a4 + a1;
  result.x[i + 1] = r1;
  a1 = h[i + 253];
  vec r2 = h[i + 2] + a1 + a7a5 + a2;
  result.x[i + 2] = r2;
  a2 = h[i + 254]; a2a0 = a2 + a0;
  vec r3 = h[i + 3] + a2a0 + a6 + a3;
  result.x[i + 3] = r3;
  a3 = h[i + 255]; a3a1 = a3 + a1;
  vec r4 = h[i + 4] + a3a1 + a7 + a4;
  result.x[i + 4] = r4;
  vec r5 = h[i + 5] + a2a0 + a5;
  result.x[i + 5] = r5;
  vec r6 = h[i + 6] + a3a1 + a6;
  result.x[i + 6] = r6;
  vec r7 = h[i + 7] + a2 + a7;
  result.x[i + 7] = r7;
  i += 8;
  r0 = h[i] + a3 + a0;
  result.x[i] = r0;
  r1 = h[i + 1] + a1;
  result.x[i + 1] = r1;
  r2 = h[i + 2] + a2;
  result.x[i + 2] = r2;
  r3 = h[i + 3] + a3;
  result.x[i + 3] = r3;
}

fieldelement operator*(const fieldelement &a,const fieldelement &b)
{
  fieldelement result;
  a.multiply(result,b);
  return result;
}

void fieldelement::putsquare(fieldelement &result) const
{
  vec *h = result.x;
  int i;
  vec a;
  vec b;
  vec u;
  vec v;
  vec w;

  b = x[129];
  v = x[130];

  for (i = 131;i < 247;i += 4) {
    a = x[i];
    u = a + v;
    h[2 * i - 244] = x[i - 122] + a; h[2 * i - 251] = u + b;
    v = x[i + 1];
    h[2 * i - 242] = x[i - 121] + v; h[2 * i - 249] = v + u;
    b = x[i + 2];
    u = b + v;
    h[2 * i - 240] = x[i - 120] + b; h[2 * i - 247] = u + a;
    v = x[i + 3];
    h[2 * i - 238] = x[i - 119] + v; h[2 * i - 245] = v + u;
  }
  
  h[250] = x[125] + x[247];
  h[243] = x[247] + v + b;
  h[245] = x[248] + x[247] + v;
  h[247] = x[249] + x[248] + x[247];
  h[249] = x[250] + x[249] + x[248];

  vec h256 = x[128] + x[250];
  vec h254 = x[127] + x[249];
  vec h253 = x[250];
  vec h252 = x[126] + x[248];
  vec h251 = x[250] + x[249];
  vec e = h256 + h254;

  h[16] = x[8] + x[130];
  h[14] = x[7] + x[129];
  h[12] = x[6] + h256;
  h[10] = x[5] + h254;
  h[8] = x[4] + h252;
  h[6] = x[3] + h253;
  h[4] = x[2] + x[249];
  h[2] = x[1] + x[249];
  h[0] = x[0] + h251;

  h[9] = x[130] + x[129] + h256 + h253;
  h[7] = x[129] + e + h251;
  h[5] = e + h252;
  h[3] = h254 + h252;
  h[1] = h252;
}

fieldelement fieldelement::square(void)
{
  fieldelement result;
  putsquare(result);
  return result;
}

void fieldelement::times_d(fieldelement &result) const
{
  vec *h = result.x;
  int i;

  for (i = 44;i < 54;++i) h[i] = x[i] + x[i - 44];
  for (i = 54;i < 57;++i) h[i] = x[i] + x[i - 44] + x[i - 54];
  for (i = 57;i < 251;++i) h[i] = x[i] + x[i - 44] + x[i - 54] + x[i - 57];

  vec a0;
  vec a1;
  vec a2;
  vec a3;
  vec a4;
  vec a5;
  vec a6;
  vec a7;
  vec a2a0;
  vec a3a1;
  vec a6a4;
  vec a7a5;
  vec r0 = x[0];
  vec r1 = x[1];
  vec r2 = x[2];
  vec r3 = x[3];
  vec r4 = x[4];
  vec r5 = x[5];
  vec r6 = x[6];
  vec r7 = x[7];

  for (i = 251;i < 283;i += 8) {
    a0 = x[i-44] + x[i-54] + x[i-57];
    r7=r7+a0; r0=r0+a0;
    h[i-251] = r0; r0 = x[i-243];
    a1 = x[i-43] + x[i-53] + x[i-56];
    r0=r0+a1; r1=r1+a1;
    h[i-250] = r1; r1 = x[i-242];
    a2 = x[i-42] + x[i-52] + x[i-55];
    a2a0 = a2 + a0;
    r1=r1+a2; r6=r6+a2; r4=r4+a2a0; r2=r2+a2a0;
    h[i-249] = r2; r2 = x[i-241];
    a3 = x[i-41] + x[i-51] + x[i-54];
    a3a1 = a3 + a1;
    r2=r2+a3; r7=r7+a3; r5=r5+a3a1; r3=r3+a3a1;
    h[i-248] = r3; r3 = x[i-240];
    a4 = x[i-40] + x[i-50] + x[i-53];
    r3=r3+a4; r4=r4+a4;
    h[i-247] = r4; r4 = x[i-239];
    a5 = x[i-39] + x[i-49] + x[i-52];
    r4=r4+a5; r5=r5+a5;
    h[i-246] = r5; r5 = x[i-238];
    a6 = x[i-38] + x[i-48] + x[i-51];
    a6a4 = a6 + a4;
    r5=r5+a6; r2=r2+a6; r0=r0+a6a4; r6=r6+a6a4;
    h[i-245] = r6; r6 = x[i-237];
    a7 = x[i-37] + x[i-47] + x[i-50];
    a7a5 = a7 + a5;
    r6=r6+a7; r3=r3+a7; r1=r1+a7a5; r7=r7+a7a5;
    h[i-244] = r7; r7 = x[i-236];
  }

    a0 = x[i-44] + x[i-54] + x[i-57];
    r7=r7+a0; r0=r0+a0;
    h[i-251] = r0; r0 = x[i-243];
    a1 = x[i-43] + x[i-53] + x[i-56];
    r0=r0+a1; r1=r1+a1;
    h[i-250] = r1; r1 = x[i-242];
    a2 = x[i-42] + x[i-52] + x[i-55];
    a2a0 = a2 + a0;
    r1=r1+a2; r6=r6+a2; r4=r4+a2a0; r2=r2+a2a0;
    h[i-249] = r2; r2 = x[i-241];
    a3 = x[i-41] + x[i-51] + x[i-54];
    a3a1 = a3 + a1;
    r2=r2+a3; r7=r7+a3; r5=r5+a3a1; r3=r3+a3a1;
    h[i-248] = r3; r3 = x[i-240];
    a4 = x[i-40] + x[i-50] + x[i-53];
    r3=r3+a4; r4=r4+a4;
    h[i-247] = r4; r4 = h[i-239];
    a5 = x[i-39] + x[i-49] + x[i-52];
    r4=r4+a5; r5=r5+a5;
    h[i-246] = r5; r5 = h[i-238];
    a6 = x[i-38] + x[i-48] + x[i-51];
    a6a4 = a6 + a4;
    r5=r5+a6; r2=r2+a6; r0=r0+a6a4; r6=r6+a6a4;
    h[i-245] = r6; r6 = h[i-237];
    a7 = x[i-37] + x[i-47] + x[i-50];
    a7a5 = a7 + a5;
    r6=r6+a7; r3=r3+a7; r1=r1+a7a5; r7=r7+a7a5;
    h[i-244] = r7; r7 = h[i-236];
    i += 8;

    a0 = x[i-44] + x[i-54] + x[i-57];
    r7=r7+a0; r0=r0+a0;
    h[i-251] = r0; r0 = h[i-243];
    a1 = x[i-43] + x[i-53] + x[i-56];
    r0=r0+a1; r1=r1+a1;
    h[i-250] = r1; r1 = h[i-242];
    a2 = x[i-42] + x[i-52] + x[i-55];
    a2a0 = a2 + a0;
    r1=r1+a2; r6=r6+a2; r4=r4+a2a0; r2=r2+a2a0;
    h[i-249] = r2; r2 = h[i-241];
    a3 = x[i-41] + x[i-51] + x[i-54];
    a3a1 = a3 + a1;
    r2=r2+a3; r7=r7+a3; r5=r5+a3a1; r3=r3+a3a1;
    h[i-248] = r3; r3 = h[i-240];
    a4 = x[i-50] + x[i-53];
    r3=r3+a4; r4=r4+a4;
    h[i-247] = r4; r4 = h[i-239];
    a5 = x[i-49] + x[i-52];
    r4=r4+a5; r5=r5+a5;
    h[i-246] = r5; r5 = h[i-238];
    a6 = x[i-48] + x[i-51];
    a6a4 = a6 + a4;
    r5=r5+a6; r2=r2+a6; r0=r0+a6a4; r6=r6+a6a4;
    h[i-245] = r6; r6 = h[i-237];
    a7 = x[i-47] + x[i-50];
    a7a5 = a7 + a5;
    r6=r6+a7; r3=r3+a7; r1=r1+a7a5; r7=r7+a7a5;
    h[i-244] = r7; r7 = h[i-236];
    i += 8;

    a0 = x[i-54] + x[i-57];
    r7=r7+a0; r0=r0+a0;
    h[i-251] = r0; r0 = h[i-243];
    a1 = x[i-53] + x[i-56];
    r0=r0+a1; r1=r1+a1;
    h[i-250] = r1; r1 = h[i-242];
    a2 = x[i-52] + x[i-55];
    a2a0 = a2 + a0;
    r1=r1+a2; r6=r6+a2; r4=r4+a2a0; r2=r2+a2a0;
    h[i-249] = r2; r2 = h[i-241];
    a3 = x[i-51] + x[i-54];
    a3a1 = a3 + a1;
    r2=r2+a3; r7=r7+a3; r5=r5+a3a1; r3=r3+a3a1;
    h[i-248] = r3; r3 = h[i-240];
    a4 = x[i-50] + x[i-53];
    r3=r3+a4; r4=r4+a4;
    h[i-247] = r4; r4 = h[i-239];
    a5 = x[i-49] + x[i-52];
    r4=r4+a5; r5=r5+a5;
    h[i-246] = r5; r5 = h[i-238];
    a6 = x[i-51];
    a6a4 = a6 + a4;
    r5=r5+a6; r2=r2+a6; r0=r0+a6a4; r6=r6+a6a4;
    h[i-245] = r6; r6 = h[i-237];
    a7 = x[i-50];
    a7a5 = a7 + a5;
    r6=r6+a7; r3=r3+a7; r1=r1+a7a5; r7=r7+a7a5;
    h[i-244] = r7; r7 = h[i-236];
    i += 8;

    a0 = x[i-57]; r7=r7+a0; r4=r4+a0; r2=r2+a0; r0=r0+a0; h[i-251] = r0;
    h[i-250] = r1;
    h[i-249] = r2;
    h[i-248] = r3;
    h[i-247] = r4;
    h[i-246] = r5;
    h[i-245] = r6;
    h[i-244] = r7;
}

fieldelement fieldelement::times_d(void)
{
  fieldelement result;
  times_d(result);
  return result;
}

fieldelement fieldelement::inverse(void)
{
  int i;
  fieldelement u;
  fieldelement v;
  fieldelement w;
  fieldelement r;
  w = (*this) * ((*this) * (*this).square()).square();
  v = w * w.square().square().square();
  u = v.square().square();
  for (i = 8;i < 12;i += 2) u = u.square().square();
  w = v * u;
  v = w.square().square();
  for (i = 14;i < 24;i += 2) v = v.square().square();
  w = (*this) * (v * w).square();
  u = w.square();
  for (i = 26;i < 50;i += 2) u = u.square().square();
  r = w * u;
  u = r.square().square();
  for (i = 52;i < 100;i += 2) u = u.square().square();
  u = (u * r).square();
  for (i = 101;i < 125;i += 2) u = u.square().square();
  v = u * w;
  u = v.square();
  for (i = 126;i < 250;i += 2) u = u.square().square();
  return (u * v).square();
}

fieldelement fieldelement::bbe251(const vec n[251])
{
  fieldelement Z2; Z2.set_1();
  fieldelement W2; W2.set_0();
  vec control = n[250];
  fieldelement W3; W3 = *this;
  fieldelement Z3; Z3.set_1();
  fieldelement C;
  fieldelement D;
  int i;
  for (i = 250;i >= 0;--i) {
    conditionalswap(W2,W3,control);
    conditionalswap(Z2,Z3,control);
    C = (Z2 + W2) * W2;
    D = (Z3 + W3) * C * W3;
    Z3 = (Z3 * Z2).square().times_d() + D;
    W2 = C.square();
    Z2 = Z2.square().square().times_d() + W2;
    W3 = Z3 * (*this) + D;
    if (i > 0) control = n[i] + n[i - 1];
  }
  conditionalswap(W2,W3,n[0]);
  conditionalswap(Z2,Z3,n[0]);
  return W2 * Z2.inverse();
}
